Index: java/main/src/main/java/com/framsticks/communication/Subscription.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/Subscription.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/communication/Subscription.java	(revision 97)
@@ -4,9 +4,10 @@
 
 import com.framsticks.communication.queries.RegistrationRequest;
+import com.framsticks.util.dispatching.AtOnceDispatcher;
 import com.framsticks.util.dispatching.Dispatcher;
 import com.framsticks.util.dispatching.Dispatching;
 import com.framsticks.util.dispatching.RunAt;
-import com.framsticks.util.FramsticksException;
-import com.framsticks.util.StateFunctor;
+import com.framsticks.util.dispatching.ThrowExceptionHandler;
+
 import org.apache.log4j.Logger;
 
@@ -19,5 +20,5 @@
 	private final static Logger log = Logger.getLogger(Subscription.class);
 
-	private final ClientConnection connection;
+	private final ClientSideManagedConnection connection;
 	private final String path;
 	private final String registeredPath;
@@ -26,5 +27,5 @@
 	private EventCallback eventCallback;
 
-	public Subscription(ClientConnection connection, String path, String registeredPath, Dispatcher<C> dispatcher) {
+	public Subscription(ClientSideManagedConnection connection, String path, String registeredPath, Dispatcher<C> dispatcher) {
 		this.connection = connection;
 		this.path = path;
@@ -46,17 +47,13 @@
 	}
 
-	public void unsubscribe(final StateFunctor stateFunctor) {
+	public void unsubscribe(final ClientSideResponseFuture future) {
 		//@todo remove that /cli/ prefix, when registeredPath will be a fully qualified path
-		connection.send(new RegistrationRequest().register(false).path(registeredPath), new ResponseCallback<Connection>() {
+		connection.send(new RegistrationRequest().register(false).path(registeredPath), AtOnceDispatcher.getInstance(), new ClientSideResponseFuture(future) {
+
 			@Override
-			public void process(Response response) {
-				if (!response.getOk()) {
-					log.error("failed to unsunscribe " + this + ": " + response.getComment());
-					stateFunctor.handle(new FramsticksException().msg("unsubscription failed").arg("comment", response.getComment()));
-					return;
-				}
+			protected void processOk(Response response) {
 				assert response.hasFiles();
 				log.debug("unsunscribed " + this);
-				stateFunctor.call();
+				future.pass(response);
 			}
 		});
@@ -76,7 +73,8 @@
 
 	public void dispatchCall(final List<File> files) {
-		Dispatching.dispatchIfNotActive(dispatcher, new RunAt<C>() {
+		//TODO TEH
+		Dispatching.dispatchIfNotActive(dispatcher, new RunAt<C>(ThrowExceptionHandler.getInstance()) {
 			@Override
-			public void run() {
+			protected void runAt() {
 				eventCallback.call(files);
 			}
Index: java/main/src/main/java/com/framsticks/communication/SubscriptionCallback.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/SubscriptionCallback.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/communication/SubscriptionCallback.java	(revision 97)
@@ -1,8 +1,17 @@
 package com.framsticks.communication;
+
+import com.framsticks.util.FramsticksException;
+import com.framsticks.util.dispatching.ExceptionResultHandler;
 
 /**
  * @author Piotr Sniegowski
  */
-public interface SubscriptionCallback<C> {
-	EventCallback subscribed(Subscription<? super C> subscription);
+public abstract class SubscriptionCallback<C> implements ExceptionResultHandler {
+	public abstract EventCallback subscribed(Subscription<? super C> subscription);
+
+	@Override
+	public void handle(FramsticksException exception) {
+		throw exception;
+	}
+
 }
Index: java/main/src/main/java/com/framsticks/communication/util/LoggingStateCallback.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/util/LoggingStateCallback.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/communication/util/LoggingStateCallback.java	(revision 97)
@@ -1,6 +1,6 @@
 package com.framsticks.communication.util;
 
-import com.framsticks.communication.StateCallback;
-import com.framsticks.util.FramsticksException;
+import com.framsticks.communication.ClientSideResponseFuture;
+import com.framsticks.communication.Response;
 
 import org.apache.log4j.Logger;
@@ -9,5 +9,5 @@
  * @author Piotr Sniegowski
  */
-public class LoggingStateCallback<C> extends StateCallback<C> {
+public class LoggingStateCallback extends ClientSideResponseFuture {
 
 	protected final Logger logger;
@@ -15,16 +15,18 @@
 
 	public LoggingStateCallback(Logger logger, String message) {
+		super(null);
 		this.logger = logger;
 		this.message = message;
 	}
 
+	// @Override
+	// public void handle(FramsticksException e) {
+	// 	logger.error("failed to " + message + " with " + e);
+	// }
+
 	@Override
-	public void handle(FramsticksException e) {
-		logger.error("failed to " + message + " with " + e);
+	protected void processOk(Response response) {
+		logger.debug(message);
 	}
 
-	@Override
-	public void callImpl() {
-		logger.debug(message);
-	}
 }
Index: java/main/src/main/java/com/framsticks/communication/util/LoggingSubscriptionCallback.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/util/LoggingSubscriptionCallback.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/communication/util/LoggingSubscriptionCallback.java	(revision 97)
@@ -9,5 +9,5 @@
  * @author Piotr Sniegowski
  */
-public class LoggingSubscriptionCallback<C> implements SubscriptionCallback<C> {
+public class LoggingSubscriptionCallback<C> extends SubscriptionCallback<C> {
 
 	protected final Logger logger;
Index: java/main/src/main/java/com/framsticks/core/AbstractTree.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/AbstractTree.java	(revision 97)
+++ java/main/src/main/java/com/framsticks/core/AbstractTree.java	(revision 97)
@@ -0,0 +1,162 @@
+package com.framsticks.core;
+import java.util.HashSet;
+import java.util.Set;
+
+import javax.annotation.Nonnull;
+
+import org.apache.log4j.Logger;
+
+import com.framsticks.params.AccessInterface;
+import com.framsticks.params.CompositeParam;
+import com.framsticks.params.FramsClass;
+import com.framsticks.params.Param;
+import com.framsticks.params.ParamsPackage;
+import com.framsticks.params.Registry;
+import com.framsticks.params.annotations.AutoAppendAnnotation;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.util.dispatching.Dispatching;
+import com.framsticks.util.dispatching.RunAt;
+import com.framsticks.util.dispatching.Thread;
+import com.framsticks.util.dispatching.ThrowExceptionHandler;
+
+/**
+ * @author Piotr Sniegowski
+ */
+@FramsClassAnnotation
+public abstract class AbstractTree extends Thread<Tree> implements Tree {
+
+	private static final Logger log = Logger.getLogger(Tree.class);
+
+	private Node root;
+
+	@Override
+	public void setRoot(Node node) {
+		root = node;
+	}
+
+	@Override
+	public @Nonnull Node getRoot() {
+		assert root != null;
+		return root;
+	}
+
+	public boolean isRootAssigned() {
+		// assert isActive();
+		return root != null;
+	}
+
+	protected Set<TreeListener> listeners = new HashSet<TreeListener>();
+
+	public AbstractTree() {
+		setName("entity");
+	}
+
+	protected void tryRegisterOnChangeEvents(Path path) {
+
+	}
+
+
+	protected void fireRun(Exception e) {
+		for (TreeListener l : this.listeners) {
+			l.onRun(e);
+		}
+	}
+
+	protected void fireStop(Exception e) {
+		for (TreeListener l : this.listeners) {
+			l.onStop(e);
+		}
+	}
+
+	@Override
+	public void addListener(final TreeListener listener) {
+		assert Dispatching.isThreadSafe();
+		Dispatching.dispatchIfNotActive(this, new RunAt<Tree>(ThrowExceptionHandler.getInstance()) {
+			@Override
+			protected void runAt() {
+				listeners.add(listener);
+			}
+		});
+	}
+
+	@Override
+	public void removeListener(final TreeListener listener) {
+		assert Dispatching.isThreadSafe();
+		Dispatching.dispatchIfNotActive(this, new RunAt<Tree>(ThrowExceptionHandler.getInstance()) {
+			@Override
+			protected void runAt() {
+				listeners.remove(listener);
+			}
+		});
+	}
+
+	protected void fireListChange(Path path, ListChange change) {
+		assert isActive();
+		for (TreeListener l : this.listeners) {
+			l.onListChange(path, change);
+		}
+	}
+
+	@Override
+	public void notifyOfFetch(Path path) {
+		fireFetch(path);
+	}
+
+	protected void fireFetch(Path path) {
+		assert isActive();
+		for (TreeListener l : this.listeners) {
+			l.onFetch(path);
+		}
+	}
+
+
+	@Override
+	public final FramsClass getInfoFromCache(String id) {
+		assert isActive();
+		return registry.getFramsClass(id);
+	}
+
+	protected Registry registry = new Registry();
+
+
+	@Override
+	public @Nonnull AccessInterface prepareAccess(CompositeParam param) {
+		return registry.prepareAccess(param);
+	}
+
+	@Override
+	public void takeAllFrom(Registry source) {
+		registry.takeAllFrom(source);
+	}
+
+	@AutoAppendAnnotation
+	public void usePackage(ParamsPackage paramsPackage) {
+		log.debug("using package " + paramsPackage + " in tree " + this);
+		paramsPackage.register(registry);
+	}
+
+	@AutoAppendAnnotation
+	public void takeFromRegistry(Registry registry) {
+		log.debug("taking from registry " + registry + " in tree " + this);
+		this.registry.takeAllFrom(registry);
+	}
+
+	@Override
+	protected void joinableStart() {
+		dispatch(new RunAt<Tree>(ThrowExceptionHandler.getInstance()) {
+			@Override
+			protected void runAt() {
+				if (!isRootAssigned()) {
+					setRoot(new Node(Param.build().name("Tree").id(getName()).type("o").finish(CompositeParam.class), null));
+				}
+			}
+		});
+		super.joinableStart();
+	}
+
+	@Override
+	public void putInfoIntoCache(FramsClass framclass) {
+		registry.putFramsClass(framclass);
+	}
+}
+
Index: java/main/src/main/java/com/framsticks/core/AbstractTreeListener.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/AbstractTreeListener.java	(revision 97)
+++ java/main/src/main/java/com/framsticks/core/AbstractTreeListener.java	(revision 97)
@@ -0,0 +1,25 @@
+package com.framsticks.core;
+
+public abstract class AbstractTreeListener implements TreeListener {
+
+	@Override
+	public void onListChange(Path path, ListChange change) {
+
+	}
+
+	@Override
+	public void onFetch(Path path) {
+
+	}
+
+	@Override
+	public void onRun(Exception e) {
+
+	}
+
+	@Override
+	public void onStop(Exception e) {
+
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/core/Framsticks.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/Framsticks.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/core/Framsticks.java	(revision 97)
@@ -29,5 +29,10 @@
 	public static void main(final String[] args) {
 
-		new Monitor(loadConfiguration(Framsticks.class.getResourceAsStream("/configs/framsticks.xml"))).use().waitFor().drop().join();
+		String config = "/configs/framsticks.xml";
+		if (args.length != 0) {
+			config = args[0];
+		}
+
+		new Monitor(loadConfiguration(Framsticks.class.getResourceAsStream(config))).use().waitFor().drop().join();
 
 		log.debug("exiting main");
Index: java/main/src/main/java/com/framsticks/core/Mode.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/Mode.java	(revision 97)
+++ java/main/src/main/java/com/framsticks/core/Mode.java	(revision 97)
@@ -0,0 +1,6 @@
+package com.framsticks.core;
+
+public enum Mode {
+	CACHE,
+	FETCH
+}
Index: java/main/src/main/java/com/framsticks/core/ObjectTree.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/ObjectTree.java	(revision 97)
+++ java/main/src/main/java/com/framsticks/core/ObjectTree.java	(revision 97)
@@ -0,0 +1,112 @@
+package com.framsticks.core;
+
+import org.apache.log4j.Logger;
+
+import com.framsticks.params.AccessInterface;
+import com.framsticks.params.CompositeParam;
+import com.framsticks.params.FramsClass;
+import com.framsticks.params.Param;
+import com.framsticks.params.PrimitiveParam;
+import com.framsticks.params.annotations.AutoAppendAnnotation;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.util.UnsupportedOperationException;
+import com.framsticks.params.types.ProcedureParam;
+import com.framsticks.util.FramsticksException;
+import com.framsticks.util.dispatching.Future;
+import static com.framsticks.core.TreeOperations.*;
+
+@FramsClassAnnotation
+public class ObjectTree extends AbstractTree {
+	private static final Logger log = Logger.getLogger(ObjectTree.class);
+
+	@AutoAppendAnnotation
+	public void setRootObject(Object object) {
+		registry.registerAndBuild(object.getClass());
+		AccessInterface access = registry.createAccess(object.getClass());
+		setRoot(new Node(Param.build().forAccess(access).id(getName()).finish(CompositeParam.class), object));
+	}
+
+	public Object getRootObject() {
+		return getRoot().getObject();
+	}
+
+	public <T> T getRootObject(Class<T> type) {
+		Object result = getRootObject();
+		if (result == null) {
+			throw new FramsticksException().msg("object tree is empty").arg("tree", this);
+		}
+		if (!type.isInstance(result)) {
+			throw new FramsticksException().msg("object tree holds object of different kind").arg("object", result).arg("requested", type).arg("tree", this);
+		}
+		return type.cast(result);
+	}
+
+	@Override
+	public void get(final Path path, Mode mode, Future<Object> future) {
+		assert isActive();
+		log.debug("requesting: " + path);
+		fireFetch(path);
+		future.pass(path.getTopObject());
+	}
+
+	@Override
+	public void get(Path path, PrimitiveParam<?> param, Mode mode, Future<Object> future) {
+		assert isActive();
+		fireFetch(path);
+		future.pass(bindAccess(path).get(param, Object.class));
+	}
+
+	@Override
+	public void call(Path path, ProcedureParam param, Object[] arguments, Future<Object> future) {
+		assert isActive();
+		try {
+			future.pass(bindAccess(path).call(param, arguments));
+		} catch (FramsticksException e) {
+			future.handle(e);
+		}
+	}
+
+	@Override
+	public void info(Path path, Future<FramsClass> future) {
+		assert isActive();
+		Path p = path.tryResolveIfNeeded();
+		Class<?> javaClass = p.getTopObject().getClass();
+		FramsClass framsClass = registry.registerReflectedIfNeeded(javaClass);
+		if (framsClass != null) {
+			future.pass(framsClass);
+		} else {
+			future.handle(new FramsticksException().msg("failed to find info for class").arg("java class", javaClass));
+		}
+	}
+
+	@Override
+	public void resolve(Path path, Future<Path> future) {
+		assert isActive();
+		assert path.isOwner(this);
+		if (path.getTop().getObject() != null) {
+			future.pass(path);
+			return;
+		}
+		AccessInterface access = bindAccess(this, path.getUnder());
+		Object object = access.get(path.getTop().getParam(), Object.class);
+		if (object == null) {
+			future.pass(path);
+			return;
+		}
+		future.pass(path.appendResolution(object));
+	}
+
+	@Override
+	public void set(Path path, PrimitiveParam<?> param, Object value, final Future<Integer> future) {
+		assert isActive();
+		future.pass(bindAccess(path).set(param, value));
+	}
+
+	@Override
+	public Path create(Path path) {
+		assert isActive();
+		assert !path.isResolved();
+		throw new UnsupportedOperationException();
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/core/Path.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/Path.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/core/Path.java	(revision 97)
@@ -23,9 +23,9 @@
 	// private final static Logger log = Logger.getLogger(Path.class.getName());
 
-	final Instance instance;
+	final Tree tree;
 	final String textual;
 	final LinkedList<Node> nodes;
 
-	protected static Object getKnownChild(Instance instance, AccessInterface access, CompositeParam param) {
+	protected static Object getKnownChild(Tree tree, AccessInterface access, CompositeParam param) {
 		Object child = access.get(param, Object.class);
 		if (child == null) {
@@ -33,5 +33,5 @@
 		}
 		try {
-			instance.prepareAccess(param);
+			tree.prepareAccess(param);
 			return child;
 		} catch (FramsticksException e) {
@@ -41,10 +41,10 @@
 
 	/**
-	 * @param instance
+	 * @param tree
 	 * @param textual
 	 * @param nodes
 	 */
-	Path(Instance instance, String textual, LinkedList<Node> nodes) {
-		this.instance = instance;
+	Path(Tree tree, String textual, LinkedList<Node> nodes) {
+		this.tree = tree;
 		this.textual = textual;
 		this.nodes = nodes;
@@ -53,5 +53,5 @@
 	public Path appendNode(Node node) {
 		assert isResolved();
-		return new PathBuilder().instance(instance).textual(textual + ((size() == 1) ? "" : "/") + node.getParam().getId()).add(nodes).add(node).finish();
+		return new PathBuilder().tree(tree).textual(textual + ((size() == 1) ? "" : "/") + node.getParam().getId()).add(nodes).add(node).finish();
 	}
 
@@ -63,12 +63,12 @@
 	public static class PathBuilder {
 
-		Instance instance;
+		Tree tree;
 		String textual;
 		final LinkedList<Node> nodes = new LinkedList<Node>();
 
 		public Path finish() {
-			assert instance != null;
+			assert tree != null;
 			assert textual != null;
-			return new Path(instance, textual, nodes);
+			return new Path(tree, textual, nodes);
 		}
 
@@ -77,6 +77,6 @@
 		}
 
-		public PathBuilder instance(Instance instance) {
-			this.instance = instance;
+		public PathBuilder tree(Tree tree) {
+			this.tree = tree;
 			return this;
 		}
@@ -130,17 +130,17 @@
 		}
 
-		public PathBuilder resolve(@Nonnull Instance instance, String textual) {
+		public PathBuilder resolve(@Nonnull Tree tree, String textual) {
 
 			assert nodes.isEmpty();
-			assert instance.isActive();
-			this.instance = instance;
-
-			nodes.add(instance.getRoot());
-			Node current = instance.getRoot();
+			assert tree.isActive();
+			this.tree = tree;
+
+			nodes.add(tree.getRoot());
+			Node current = tree.getRoot();
 
 			StringBuilder b = new StringBuilder();
 			Iterator<String> i = splitPath(textual);
 			while (i.hasNext() && current.getObject() != null) {
-				AccessInterface access = instance.prepareAccess(current.getParam());
+				AccessInterface access = tree.prepareAccess(current.getParam());
 				if (access == null) {
 					break;
@@ -155,5 +155,5 @@
 				b.append("/").append(e);
 				access.select(current.getObject());
-				current = new Node(c, getKnownChild(instance, access, c));
+				current = new Node(c, getKnownChild(tree, access, c));
 				nodes.add(current);
 			}
@@ -170,5 +170,5 @@
 	public Path appendResolution(Object object) {
 		assert !isResolved();
-		Path result = new PathBuilder().textual(textual).instance(instance).add(nodes).setLast(object).finish();
+		Path result = new PathBuilder().textual(textual).tree(tree).add(nodes).setLast(object).finish();
 		assert size() == result.size();
 		return result;
@@ -193,5 +193,9 @@
 
 	public String toString() {
-		return instance + textual + (!isResolved() ? "!" : "");
+		return tree + textual + (!isResolved() ? "!" : "");
+	}
+
+	public String getFullTextual() {
+		return tree.getName() + textual;
 	}
 
@@ -216,7 +220,7 @@
 	}
 
-	public final @Nonnull Instance getInstance() {
-		assert Dispatching.isThreadSafe();
-		return instance;
+	public final @Nonnull Tree getTree() {
+		assert Dispatching.isThreadSafe();
+		return tree;
 	}
 
@@ -233,10 +237,10 @@
 	 */
 	public Path tryFindResolution() {
-		assert instance.isActive();
+		assert tree.isActive();
 		assert !isResolved();
 		if (size() == 1) {
-			return Path.build().resolve(instance, "/").finish();//appendResolution(instance.root.object);
-		}
-		Object child = getKnownChild(instance, InstanceUtils.bindAccess(instance, getUnder()), getTop().getParam());
+			return Path.build().resolve(tree, "/").finish();
+		}
+		Object child = getKnownChild(tree, TreeOperations.bindAccess(tree, getUnder()), getTop().getParam());
 		if (child == null) {
 			return this;
@@ -247,5 +251,5 @@
 	public boolean matches(Path p) {
 		assert Dispatching.isThreadSafe();
-		assert instance == p.instance;
+		assert tree == p.tree;
 		Iterator<Node> a = nodes.iterator();
 		Iterator<Node> b = p.nodes.iterator();
@@ -264,11 +268,7 @@
 	}
 
-	public final boolean isOwner(Instance instance) {
-		return this.instance == instance;
-	}
-
-	// public void setInstance(Instance instance) {
-	//	this.instance = instance;
-	// }
+	public final boolean isOwner(Tree tree) {
+		return this.tree == tree;
+	}
 
 	@SuppressWarnings("unchecked")
@@ -284,6 +284,6 @@
 	}
 
-	public static Path to(@Nonnull Instance instance, String textual) {
-		return Path.build().resolve(instance, textual).finish();
+	public static Path to(@Nonnull Tree tree, String textual) {
+		return Path.build().resolve(tree, textual).finish();
 	}
 }
Index: java/main/src/main/java/com/framsticks/core/Tree.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/Tree.java	(revision 97)
+++ java/main/src/main/java/com/framsticks/core/Tree.java	(revision 97)
@@ -0,0 +1,45 @@
+package com.framsticks.core;
+
+import javax.annotation.Nonnull;
+
+import com.framsticks.params.AccessInterface;
+import com.framsticks.params.CompositeParam;
+import com.framsticks.params.FramsClass;
+import com.framsticks.params.PrimitiveParam;
+import com.framsticks.params.Registry;
+import com.framsticks.params.types.ProcedureParam;
+import com.framsticks.util.dispatching.Dispatcher;
+import com.framsticks.util.dispatching.Future;
+import com.framsticks.util.dispatching.Joinable;
+
+public interface Tree extends Dispatcher<Tree>, Joinable {
+
+	public @Nonnull Node getRoot();
+	public @Nonnull void setRoot(Node node);
+
+	public @Nonnull AccessInterface prepareAccess(CompositeParam param);
+	public void takeAllFrom(Registry source);
+
+	public void addListener(TreeListener listener);
+	public void removeListener(TreeListener listener);
+
+	public void notifyOfFetch(Path path);
+
+	public FramsClass getInfoFromCache(String id);
+
+	public void putInfoIntoCache(FramsClass framclass);
+
+	public void resolve(Path path, Future<Path> future);
+
+	public void get(Path path, PrimitiveParam<?> param, Mode mode, Future<Object> future);
+
+	public void get(Path path, Mode mode, Future<Object> future);
+
+	public void call(Path path, ProcedureParam param, Object[] arguments, Future<Object> future);
+
+	public void set(Path path, PrimitiveParam<?> param, Object value, Future<Integer> future);
+
+	public void info(Path path, Future<FramsClass> future);
+
+	public Path create(Path path);
+}
Index: java/main/src/main/java/com/framsticks/core/TreeListener.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/TreeListener.java	(revision 97)
+++ java/main/src/main/java/com/framsticks/core/TreeListener.java	(revision 97)
@@ -0,0 +1,11 @@
+package com.framsticks.core;
+
+/**
+ * @author Piotr Sniegowski
+ */
+public interface TreeListener {
+	public void onListChange(Path path, ListChange change);
+	public void onFetch(Path path);
+	public void onRun(Exception e);
+	public void onStop(Exception e);
+}
Index: java/main/src/main/java/com/framsticks/core/TreeOperations.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/TreeOperations.java	(revision 97)
+++ java/main/src/main/java/com/framsticks/core/TreeOperations.java	(revision 97)
@@ -0,0 +1,246 @@
+package com.framsticks.core;
+
+import java.util.List;
+
+import javax.annotation.Nonnull;
+
+import org.apache.log4j.Logger;
+
+import com.framsticks.communication.File;
+import com.framsticks.params.AccessInterface;
+import com.framsticks.params.CompositeParam;
+import com.framsticks.params.FramsClass;
+import com.framsticks.params.ListAccess;
+import com.framsticks.params.Param;
+import com.framsticks.params.PrimitiveParam;
+import com.framsticks.params.ValueParam;
+import com.framsticks.params.types.ObjectParam;
+import com.framsticks.params.types.ProcedureParam;
+import com.framsticks.parsers.Loaders;
+import com.framsticks.parsers.MultiParamLoader;
+import com.framsticks.util.FramsticksException;
+import com.framsticks.util.dispatching.Future;
+import com.framsticks.util.dispatching.FutureHandler;
+import com.framsticks.util.dispatching.RunAt;
+
+import static com.framsticks.util.dispatching.Dispatching.*;
+
+public final class TreeOperations {
+
+	private static final Logger log = Logger.getLogger(TreeOperations.class.getName());
+
+	private TreeOperations() {
+	}
+
+	public static @Nonnull FramsClass processFetchedInfo(Tree tree, File file) {
+		assert tree.isActive();
+		FramsClass framsClass = Loaders.loadFramsClass(file.getContent());
+		if ("/".equals(file.getPath())) {
+			if (tree.getRoot().getParam().getContainedTypeName() == null) {
+				tree.setRoot(new Node(Param.build().name("Tree").id(tree.getName()).type("o " + framsClass.getId()).finish(CompositeParam.class), tree.getRoot().getObject()));
+			}
+		}
+		tree.putInfoIntoCache(framsClass);
+		return framsClass;
+	}
+
+	public static FramsClass getInfo(Path path) {
+		Tree tree = path.getTree();
+		assert tree.isActive();
+		final String name = path.getTop().getParam().getContainedTypeName();
+		return tree.getInfoFromCache(name);
+	}
+
+	public static void findInfo(final Path path, final Future<FramsClass> future) {
+		try {
+			Tree tree = path.getTree();
+			assert tree.isActive();
+			final FramsClass framsClass = getInfo(path);
+			if (framsClass != null) {
+				future.pass(framsClass);
+				return;
+			}
+			tree.info(path, future);
+		} catch (FramsticksException e) {
+			future.handle(e);
+		}
+	}
+
+	public static void processFetchedValues(Path path, List<File> files) {
+		Tree tree = path.getTree();
+		assert tree.isActive();
+		assert files.size() == 1;
+		assert path.isTheSame(files.get(0).getPath());
+		Node node = path.getTop();
+		MultiParamLoader loader = new MultiParamLoader();
+		loader.setNewSource(files.get(0).getContent());
+		loader.addBreakCondition(MultiParamLoader.Status.AfterObject);
+
+		try {
+			if (node.getParam() instanceof ObjectParam) {
+				loader.addAccessInterface(TreeOperations.bindAccess(tree, node));
+				loader.go();
+				tree.notifyOfFetch(path);
+				return;
+			}
+
+			ListAccess listAccess = ((ListAccess) TreeOperations.bindAccess(tree, node));
+			assert listAccess != null;
+			listAccess.clearValues();
+
+			AccessInterface elementAccess = listAccess.getElementAccess();
+			loader.addAccessInterface(elementAccess);
+			MultiParamLoader.Status status;
+			while ((status = loader.go()) != MultiParamLoader.Status.Finished) {
+				if (status == MultiParamLoader.Status.AfterObject) {
+					AccessInterface accessInterface = loader.getLastAccessInterface();
+
+					String id = listAccess.computeIdentifierFor(accessInterface.getSelected());
+					//TODO listAccessParam
+					Param param = Param.build().forAccess(accessInterface).id(id).finish();
+					Object child = accessInterface.getSelected();
+					accessInterface.select(null);
+					assert child != null;
+					TreeOperations.bindAccess(tree, node).set((ValueParam) param, child);
+				}
+			}
+
+			tree.notifyOfFetch(path);
+		} catch (Exception e) {
+			log.error("exception occurred while loading: " + e);
+		}
+
+	}
+
+	public static void resolveAndGet(final Tree tree, final String targetPath, final Future<Path> future) {
+		resolve(tree, targetPath, new FutureHandler<Path>(future) {
+			@Override
+			protected void result(final Path path) {
+				assert path.isResolved(targetPath);
+				//TODO Future
+				tree.get(path, Mode.FETCH, new FutureHandler<Object>(future) {
+					@Override
+					protected void result(Object object) {
+						future.pass(path);
+					}
+				});
+			}
+		});
+	}
+
+
+	public static void resolve(final Path path, final Future<Path> future) {
+		final Tree tree = path.getTree();
+		assert tree.isActive();
+		if (path.getTop().getObject() != null) {
+			if (getInfoFromCache(path) != null) {
+				future.pass(path);
+				return;
+			}
+			TreeOperations.findInfo(path, new FutureHandler<FramsClass>(future) {
+				@Override
+				protected void result(FramsClass result) {
+					future.pass(path);
+				}
+			});
+			return;
+		}
+		TreeOperations.findInfo(path, new FutureHandler<FramsClass>(future) {
+			@Override
+			protected void result(FramsClass result) {
+				assert tree.isActive();
+				assert path.getTop().getParam().isMatchingContainedName(result.getId());
+				Path p = (path.getTop().getParam().getContainedTypeName() != null ? path : path.tryFindResolution());
+				future.pass(TreeOperations.createIfNeeded(p));
+			}
+		});
+	}
+
+	public static Path createIfNeeded(Tree tree, String path) {
+		assert tree.isActive();
+		Path p;
+		while (!(p = Path.to(tree, path)).isResolved(path)) {
+			tree.create(p);
+		}
+		return p;
+	}
+
+	public static Path createIfNeeded(Path path) {
+		Tree tree = path.getTree();
+		assert tree.isActive();
+		if (path.isResolved()) {
+			return path;
+		}
+		return tree.create(path);
+	}
+
+	public static @Nonnull AccessInterface bindAccess(Tree tree, String path) {
+		return bindAccess(Path.to(tree, path));
+	}
+
+	public static @Nonnull AccessInterface bindAccess(Tree tree, Node node) {
+		assert tree.isActive();
+		assert node.getObject() != null;
+
+		try {
+			return tree.prepareAccess(node.getParam()).select(node.getObject());
+		} catch (FramsticksException e) {
+			throw new FramsticksException().msg("failed to prepare access for param").arg("param", node.getParam()).cause(e);
+			// log.error("failed to bind access for " + node.getParam() + ": " + e);
+		}
+	}
+
+	public static @Nonnull AccessInterface bindAccess(Path path) {
+		assert path.getTree().isActive();
+		path.assureResolved();
+		return bindAccess(path.getTree(), path.getTop());
+	}
+
+	public static void set(final Path path, final PrimitiveParam<?> param, final Object value, final Future<Integer> future) {
+		final Tree tree = path.getTree();
+
+		dispatchIfNotActive(tree, new RunAt<Tree>(future) {
+			@Override
+			protected void runAt() {
+				tree.set(path, param, value, future);
+			}
+		});
+	}
+
+	public static void call(final Path path, final ProcedureParam param, final Object[] arguments, final Future<Object> future) {
+		final Tree tree = path.getTree();
+
+		dispatchIfNotActive(tree, new RunAt<Tree>(future) {
+			@Override
+			protected void runAt() {
+				tree.call(path, param, arguments, future);
+			}
+		});
+	}
+
+	/** This might not be correct. */
+	public static void resolve(final Tree tree, final String targetPath, final Future<Path> future) {
+		dispatchIfNotActive(tree, new RunAt<Tree>(future) {
+
+			@Override
+			protected void runAt() {
+				tree.resolve(Path.to(tree, targetPath), new FutureHandler<Path>(future) {
+					@Override
+					protected void result(Path result) {
+						assert result.getTree().isActive();
+						if (result.isResolved(targetPath)) {
+							future.pass(result);
+							return;
+						}
+						resolve(tree, targetPath, future);
+					}
+				});
+			}
+		});
+	}
+
+	public static FramsClass getInfoFromCache(Path path) {
+		assert path.getTree().isActive();
+		return path.getTree().getInfoFromCache(path.getTop().getParam().getContainedTypeName());
+	}
+}
